---
title: Create a list
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Rules Lists](https://developers.cloudflare.com/api/go/resources/rules)

[Lists](https://developers.cloudflare.com/api/go/resources/rules/subresources/lists)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create a list

client.Rules.Lists.New(ctx, params) (\*[ListNewResponse](<https://developers.cloudflare.com/api/go/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/rules/lists

Creates a new list of the specified kind.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account Filter Lists Edit`

##### ParametersExpand Collapse

<details>

<summary>

params ListNewParams

</summary>

AccountID param.Field\[string]

Path param: The Account ID for this resource.

maxLength32

minLength32

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

<details>

<summary>

Kind param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/rules/subresources/lists/methods/create#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)">ListNewParamsKind</a>]

Body param: The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

</summary>

const ListNewParamsKindIP <a href="https://developers.cloudflare.com/api/go/resources/rules/subresources/lists/methods/create#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)">ListNewParamsKind</a> = "ip"

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const ListNewParamsKindRedirect <a href="https://developers.cloudflare.com/api/go/resources/rules/subresources/lists/methods/create#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)">ListNewParamsKind</a> = "redirect"

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const ListNewParamsKindHostname <a href="https://developers.cloudflare.com/api/go/resources/rules/subresources/lists/methods/create#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)">ListNewParamsKind</a> = "hostname"

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

const ListNewParamsKindASN <a href="https://developers.cloudflare.com/api/go/resources/rules/subresources/lists/methods/create#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)">ListNewParamsKind</a> = "asn"

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind">Link to this property</a>

Name param.Field\[string]

Body param: An informative name for the list. Use this name in filter and rule expressions.

maxLength50

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20name">Link to this property</a>

Description param.Field\[string]Optional

Body param: An informative summary of the list.

maxLength500

<a href="#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20description">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type ListNewResponse struct{…}

</summary>

ID string

The unique ID of the list.

maxLength32

minLength32

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

CreatedOn string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20created_on">Link to this property</a>

<details>

<summary>

Kind ListNewResponseKind

The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

</summary>

One of the following:

const ListNewResponseKindIP ListNewResponseKind = "ip"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%200">Link to this property</a>

const ListNewResponseKindRedirect ListNewResponseKind = "redirect"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%201">Link to this property</a>

const ListNewResponseKindHostname ListNewResponseKind = "hostname"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%202">Link to this property</a>

const ListNewResponseKindASN ListNewResponseKind = "asn"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

ModifiedOn string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20modified_on">Link to this property</a>

Name string

An informative name for the list. Use this name in filter and rule expressions.

maxLength50

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

NumItems float64

The number of items in the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20num_items">Link to this property</a>

NumReferencingFilters float64

The number of <a href="https://developers.cloudflare.com/api/resources/filters/">filters</a> referencing the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20num_referencing_filters">Link to this property</a>

Description stringOptional

An informative summary of the list.

maxLength500

<a href="#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20ListNewResponse%20%3E%20(schema)>)

### Create a list

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/rules"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  list, err := client.Rules.Lists.New(context.TODO(), rules.ListNewParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Kind: cloudflare.F(rules.ListNewParamsKindIP),
    Name: cloudflare.F("list1"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", list.ID)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "2c0fc9fa937b11eaa1b71c4d701ab86e",
    "created_on": "2020-01-01T08:00:00Z",
    "kind": "ip",
    "modified_on": "2020-01-10T14:00:00Z",
    "name": "list1",
    "num_items": 10,
    "num_referencing_filters": 2,
    "description": "This is a note"
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "2c0fc9fa937b11eaa1b71c4d701ab86e",
    "created_on": "2020-01-01T08:00:00Z",
    "kind": "ip",
    "modified_on": "2020-01-10T14:00:00Z",
    "name": "list1",
    "num_items": 10,
    "num_referencing_filters": 2,
    "description": "This is a note"
  },
  "success": true
}
```